<?php

class e_section_widget {
	function __construct() {
		// my widget
		add_action('wp_dashboard_setup', array(&$this, 'e_section_add_dashboard_widgets' ));
		add_action('wp_ajax_post_e_section_widget_save', array(&$this, 'post_e_section_widget_save'));
	}

	function e_section_dashboard_widget_function() {
		// Display whatever it is you want to show
?>
<form method="post" action="" name="post" id="e-section-widget-post">
	<?php if ($_POST['_wpnonce']) {

		if (wp_verify_nonce($_POST['_wpnonce'], 'add-post') < 1) {
			// TODO
			$rv = "<div class='error'><p>";
			$rv .= "An error occurred and the post could not be created";
			$rv .= "</p></div>";
			print $rv;
		} else {

			$title = $_POST['e-section-widget-title'];
			$cat = $_POST['e-section-widget-category'];

			$e_section = '';
			$e_section_page = '';
			$e_section_date = '';

			if ($_POST['special_section']) {
				$e_section_page = $_POST['print_tag'];
				$e_sections_additional_sections = unserialize(get_option('e_sections_additional_sections'));
				foreach ($e_sections_additional_sections as $section) {
					if ($section['name'] == strtoupper($_POST['special_section'])) {
						$e_section = $section['name'];
						$e_section_date = date('Y-m-d', strtotime($section['pub_date']));
					}
				}
			} else {
				list($e_section, $e_section_page) = explode('-', $_POST['print_tag']);
				$e_section_date = date('Y-m-d', strtotime($_POST['print-tag-date']));
			}

			$args = array('post_status' => 'draft');
			if ($title) { $args['post_title'] = $title; }
			else {
				$args['post_title'] = '(no title)';
			}

			$post_id = wp_insert_post($args, $wp_error);
			if ($post_id) {
				if ($cat) { wp_set_post_terms($post_id, $cat, 'category'); }
				if ($e_section) { add_post_meta($post_id, 'e_section', strtolower($e_section)); }
				if ($e_section_page) { add_post_meta($post_id, 'e_section_page', $e_section_page); }
				if ($e_section_date) { add_post_meta($post_id, 'e_section_date', $e_section_date); }
				$rv = "<div class='updated'><p>";
				$rv .= 'Draft saved. <a href="' . admin_url() . 'post.php?post=' . $post_id  . '&action=edit">Edit Post</a>';
				$rv .= "</p></div>";
				print $rv;
			} else {
				$rv = "<div class='error'><p>";
				$rv .= "An error occurred and the post could not be created";
				$rv .= "</p></div>";
				print $rv;
			}
		}
	} ?>
<div class="input-text-wrap" id="e-section-widget-title-wrap">
	<input type="text" name="e-section-widget-title" id="e-section-widget-title"
	autocomplete="off" value="Enter Title Here" style="color: #cdcdcd;">
</div>
<br/>

<div id="e-section-widget-category-wrap">
 <?php
	wp_dropdown_categories(array('hide_empty' => 0, 'name' => 'e-section-widget-category',
		'orderby' => 'name', 'selected' => $category->parent, 'hierarchical' => true,
		'show_option_none' => __('Select Category')));
  ?>
</div>
<br/>
<div id="print-tags">
<?php
        global $post;
        $print_tag_options = get_option('print_tag_options');
        $sections = get_option("e_sections_additional_sections", serialize(array()));
        $pages = get_option("e_sections_spectal_section_pages", 20);
        if (!is_array($sections)) {
            $sections = unserialize($sections);
        }
?>
        <style>
        .print-tag-section {
            font-size: 26px;
            font-weight: bold;
        }

        .print-tag-pages, .special-print-tag-pages {
            font-size: 16px;
            padding: 4px;
            margin: 2px;
        }
        </style>

            <table id="print-tag-table">
    <?php
            $print_tags = array();
            for ($i=1; $i<=$print_tag_options['number_of_sections']; $i++) {
    ?>
            <tr>
                <th class="print-tag-section">
                    <?php echo $print_tag_options['section_name_' . $i]; ?>
                </th>

                <td class="print-tag-pages">
    <?php
                for ($j=1; $j<=$print_tag_options['page_count_' . $i]; $j++) {
                    $tag = $print_tag_options['section_name_' . $i] . "-" . $j;
                    array_push($print_tags, $tag);
                    echo "<span id=\"" . $tag . "\" class=\"" . $tag . "\"> " . $j . " </span>";
                }
    ?>
                </td>
            </tr>
    <?php
            }
    ?>

    <?php if ($sections) { ?>
    <tr>
        <td colspan="2"><strong>Additional Section: </strong>
        <select name="special_section">
        <option value="">--- select ---</option>
        <?php for ($x = 1; $x<=count($sections); $x++) {
            echo "<option value=\"" . strtolower($sections[$x]["name"]) ."\">". $sections[$x]["title"] . "</option>\n";
        } ?>
        </select>
                <tr id="special_section_pages" style="display: none;">
                    <th class="print-tag-section">S</th>

                    <td class="special-print-tag-pages">
                    <?php
/*                        for ($j=1; $j<=$pages; $j++) {
                            $tag = $j;
                            array_push($print_tags, $tag);
                            echo "<span id=\"" . $tag . "\"> " . $j . " </span>";
                        } */

                    for ($x = 1; $x<=count($sections); $x++) {
                        echo "<div id=\"" . strtolower($sections[$x]["name"]) . "-pages\" class=\"ss-pages\" style=\"display: none;\">";
                        for ($j=1; $j<=$sections[$x]["pages"]; $j++) {
                            $tag = $j;
//                            array_push($print_tags, $tag);
                            echo "<span id=\"" . $tag . "\"> " . $j . " </span>";
                        }
                        echo "</div>";
                    }
                    ?>
                    </td>
                </tr>
    <?php } ?>


            <?php
                $print_tag_date = strftime("%b %d %Y", time() + 86400);
            ?>
            <tr>
            <td colspan="2"><span id="print_date">Print Date: <input type="text" class="date-pick" name="print-tag-date" value="<?php echo $print_tag_date; ?>"/></span></td>
            </tr>
            </table>

            <input type="hidden" name="print_tag" value=""/>
      <script type="text/javascript">
                jQuery.noConflict();
                jQuery(document).ready(function($){
                    $('select[name=special_section]').change(function() {
                     if ($(this).val()) {
                         $(".ss-pages").hide();
                         $("#special_section_pages").show();
                         $("#" + $(this).val() + "-pages").show();
                         $('input[name=print-tag-date]').attr('disabled','disabled');
                         $("#print_date").hide();
                         $(".special-print-tag-pages span").css("color", "black");
                         $(".special-print-tag-pages span").css("font-weight", "normal");
                        $(":input[name=print_tag]").val("");
                     } else {
                         $("#special_section_pages").hide();
                         $(".ss-pages").hide();
                         $('input[name=print-tag-date]').removeAttr('disabled');
                         $(":input[name=print_tag]").val("");

                     }
                    });
                    $('input[name=print-tag-date]').datepicker({
    				dateFormat: 'M dd yy'
                			});
                    $(".print-tag-pages span").click(function(e) {
                        $(".print-tag-pages span").css("color", "black");
                        $("#" + e.target.id.toUpperCase()).css("color", "red");
                        $(".print-tag-pages span").css("font-weight", "normal");
                        $("#" + e.target.id).css("font-weight", "bold");
                        $(":input[name=print_tag]").val(e.target.id);
                        $('select[name=special_section]').val("");
                        $("#special_section_pages").hide();
                        $('input[name=print-tag-date]').removeAttr('disabled');
                        $("#print_date").show();
                    });

                    $(".special-print-tag-pages span").click(function(e) {
                        $(".special-print-tag-pages span").css("color", "black");
                        $(".ss-pages > span[id=" + e.target.id + "]").css("color", "red");
                        $(".print-tag-pages span").css("color", "black");
                        $(".print-tag-pages span").css("font-weight", "normal");
                        $(".special-print-tag-pages span").css("font-weight", "normal");
                        $(".ss-pages > span[id=" + e.target.id + "]").css("font-weight", "bold");
                        $(":input[name=print_tag]").val(e.target.id);
                    });

                    <?php
                    $section = get_post_meta($post->ID, 'e_section', true);
                    $page = get_post_meta($post->ID, 'e_section_page', true);

                    $tag = strtoupper($section . "-" .$page);
                    ?>
                    $("#<?php echo $tag; ?>").css("color", "red");
                    $("#<?php echo $tag; ?>").css("font-weight", "bold");
                    $(":input[name=print_tag]").val("<?php echo $tag ?>");
                    $('select[name=special_section]').val("<?php echo $section?>");
                    if ($('select[name=special_section]').val() != "") {
                        $("#" + $('select[name=special_section]').val() + "-pages").show();
                        $(".ss-pages > span[id=<?php echo $page ?>]").css("color", "red");
                        $(".ss-pages > span[id=<?php echo $page ?>]").css("font-weight", "bold");
                        $('input[name=print-tag-date]').attr('disabled','disabled');
                        $("#print_date").hide();
                        $("#special_section_pages").show();
                        $(":input[name=print_tag]").val("<?php echo $page; ?>");
                    }
                });
            </script>
        </div>
		<p class="submit">
			<input type="hidden" name="action" id="e-section-widget-action" value="post_e_section_widget_save" />
			<input type="hidden" name="post_type" value="post" />
			<?php wp_nonce_field('add-post'); ?>
			<span id="save-action">
			<?php submit_button( __( 'Save Draft' ), 'button', 'save', false, array( 'id' => 'save-post' ) ); ?>
			</span>
			<span id="reset-action">
			<input type="reset" value="<?php esc_attr_e( 'Reset' ); ?>" class="button" />
			</span>
			<br class="clear" />
		</p>
</form>
<?php
	}

	// Create the function use in the action hook

	function e_section_add_dashboard_widgets() {
		wp_add_dashboard_widget('e_section_dashboard_widget', 'E-Section "QuickPress"', array(&$this, 'e_section_dashboard_widget_function'));
	}

	function post_e_section_widget_save() {

		if (wp_verify_nonce($_POST['_wpnonce'], 'add-post') < 1) {
			die("Invalid Form Submission");
		}

		$title = $_POST['e-section-widget-title'];
		$cat = $_POST['e-section-widget-category'];

		$e_section = '';
		$e_section_page = '';
		$e_section_date = '';

		 // print_r($_POST);
		if ($_POST['special_section']) {
			$e_section_page = $_POST['print_tag'];
			$e_sections_additional_sections = unserialize(get_option('e_sections_additional_sections'));
			foreach ($e_sections_additional_sections as $section) {
				if ($section['name'] == strtoupper($_POST['special_section'])) {
					$e_section = $section['name'];
					$e_section_date = date('Y-m-d', strtotime($section['pub_date']));
				}
			}
		} else {
			list($e_section, $e_section_page) = explode('-', $_POST['print_tag']);
			$e_section_date = date('Y-m-d', strtotime($_POST['print-tag-date']));
		}

		$args = array('post_status' => 'draft');
		if ($title) { $args['post_title'] = $title; }
		else {
			$args['post_title'] = '(no title)';
		}

		$post_id = wp_insert_post($args, $wp_error);
		if ($post_id) {
			if ($cat) { wp_set_post_terms($post_id, $cat, 'category'); }
			if ($e_section) { add_post_meta($post_id, 'e_section', strtolower($e_section)); }
			if ($e_section_page) { add_post_meta($post_id, 'e_section_page', $e_section_page); }
			if ($e_section_date) { add_post_meta($post_id, 'e_section_date', $e_section_date); }
			$rv = "<div class='updated'><p>";
			$rv .= 'Draft saved. <a href="' . admin_url() . 'post.php?post=' . $post_id  . '&action=edit">Edit Post</a>';
			$rv .= "</p></div>";
		} else {
			$rv = "<div class='error'><p>";
			$rv .= "An error occurred and the post could not be created";
			$rv .= "</p></div>";
		}
		die($rv);
	}
}
